#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>

char *argv0;

int setrandomseed(void)
{
  struct timeval tv;
  unsigned int seed;
  
  gettimeofday(&tv, NULL);
  seed = (unsigned int) tv.tv_usec +
  	(unsigned int) tv.tv_sec;
  
  srand(seed);

  return 0;
}

int bernoulli(double p)
{
  if ((double) rand() / (double) RAND_MAX < p)
    return 1;
  else
    return 0;
}

void usage(void)
{
  fprintf(stderr, "usage: %s <bias 0.0-1.0> <# of bytes>\ne.g.: %s 0.3 100\n",
    argv0, argv0);
  exit(-1);
}

int main(int argc, char *argv[])
{
  int N, i, bit;
  double p;
  char byte;

  argv0 = argv[0];

  setrandomseed();

  if (argc < 3)
    usage();

  p = atof(argv[1]);
  N = atoi(argv[2]);

  while (N--)
  {
    for (i = 0; i < 8; i++)
    {
      bit = bernoulli(p);
      byte = byte << 1 | bit;
    }
      
    fwrite(&byte, 1, 1, stdout);
  }

  return 0;
}
